/**
 *	@file	Misc.h
 *	@biref	undonutɈˑȂƔėpIȎGȃ[`Q
 */
#ifndef MISC_H
#define MISC_H

#pragma once

#include <stdarg.h>
#include <io.h>
#include <vector>
//#include <atlmisc.h>

namespace Misc {


// ==========================================================================

///+++ printfwŕ
const CString StrFmt(const TCHAR* fmt, ...);
const CString StrVFmt(const TCHAR* fmt, va_list app);

///+++ 󔒂ŋ؂ꂽŏ̕Ԃ.
const CString GetStrWord(const TCHAR* str, const TCHAR** ppNext=0);

///+++ 󔒂ŋ؂ꂽP𕪉
void SeptTextToWords(std::vector<CString>& strs, const TCHAR* line);

///+++ sŕ. (s͖)
void SeptTextToLines(std::vector<CString>& strs, const TCHAR* text);


///+++ ȈՂȁApZł̕ǂJEgB
unsigned	eseHankakuStrLen(const TCHAR* s);

///+++ 񔼊pwŎw肳ꂽ܂ł̕Ԃ.
const CString eseHankakuStrLeft(const CString& str, unsigned len);


// ==========================================================================
// +++ R[hϊ.

const std::vector<char> 	sjis_to_sjis (const char*    pSjis);	//+++
const std::vector<wchar_t> 	wcs_to_wcs   (const wchar_t* pWcs );	//+++

const std::vector<char> 	wcs_to_sjis  (const wchar_t* pWcs);		//+++
const std::vector<wchar_t> 	sjis_to_wcs  (const char*    pSjis);	//+++

const std::vector<char> 	sjis_to_utf8 (const char*    pSjis);	//+++
const std::vector<char> 	utf8_to_sjis (const char*    pUtf8);	//+++

const std::vector<char> 	wcs_to_utf8  (const wchar_t* pWcs);		//+++
const std::vector<wchar_t> 	utf8_to_wcs  (const char*    pUtf8);	//+++

const std::vector<char> 	sjis_to_eucjp(const char*    pSjis);	//+++
const std::vector<char> 	eucjp_to_sjis(const char*    pEucjp);	//+++

const std::vector<char> 	wcs_to_eucjp (const wchar_t* pWcs);		//+++
const std::vector<wchar_t> 	eucjp_to_wcs (const char*    pEucjp);	//+++

//+++
#ifdef UNICODE	// Unicodex[XŃRpCꍇ
__inline const std::vector<char>    tcs_to_sjis (const TCHAR*   pTcs  ) { return wcs_to_sjis (pTcs); }
__inline const std::vector<char>    tcs_to_utf8 (const TCHAR*   pTcs  ) { return wcs_to_utf8 (pTcs); }
__inline const std::vector<char>    tcs_to_eucjp(const TCHAR*   pTcs  ) { return wcs_to_eucjp(pTcs); }
__inline const std::vector<wchar_t> tcs_to_wcs  (const TCHAR*   pTcs  ) { return wcs_to_wcs  (pTcs); }

__inline const std::vector<TCHAR>   sjis_to_tcs (const char*    pSjis ) { return sjis_to_wcs (pSjis ); }
__inline const std::vector<TCHAR>   utf8_to_tcs (const char*    pUtf8 ) { return utf8_to_wcs (pUtf8 ); }
__inline const std::vector<TCHAR>   eucjp_to_tcs(const char*    pEucjp) { return eucjp_to_wcs(pEucjp); }
__inline const std::vector<TCHAR>   wcs_to_tcs  (const wchar_t* pWcs  ) { return wcs_to_wcs  (pWcs); }
#else			// MultiByte(sjis)x[XŃRpCꍇ.
__inline const std::vector<char>    tcs_to_sjis (const TCHAR*   pTcs  ) { return sjis_to_sjis (pTcs); }
__inline const std::vector<char>    tcs_to_eucjp(const TCHAR*   pTcs  ) { return sjis_to_eucjp(pTcs); }
__inline const std::vector<char>    tcs_to_utf8 (const TCHAR*   pTcs  ) { return sjis_to_utf8 (pTcs); }
__inline const std::vector<wchar_t> tcs_to_wcs  (const TCHAR*   pTcs  ) { return sjis_to_wcs  (pTcs); }

__inline const std::vector<TCHAR>   sjis_to_tcs (const char*    pSjis ) { return sjis_to_sjis (pSjis ); }
__inline const std::vector<TCHAR>   utf8_to_tcs (const char*    pUtf8 ) { return utf8_to_sjis (pUtf8 ); }
__inline const std::vector<TCHAR>   eucjp_to_tcs(const char*    pEucjp) { return eucjp_to_sjis(pEucjp); }
__inline const std::vector<TCHAR>   wcs_to_tcs  (const wchar_t* pWcs  ) { return wcs_to_sjis  (pWcs  ); }
#endif

__inline const CString sjis_to_CString(const char* pSjis)   { return CString( pSjis ); }
__inline const CString utf8_to_CString(const char* pUtf8)   { return CString(& utf8_to_tcs (pUtf8 )[0]); }
__inline const CString eucjp_to_CString(const char* pEucjp) { return CString(& eucjp_to_tcs(pEucjp)[0]); }

__inline const CString sjis_to_CString(const std::vector<char>& sjis)   { return CString( &sjis[0] ); }
__inline const CString utf8_to_CString(const std::vector<char>& utf8)   { return CString(& utf8_to_tcs (&utf8[0])[0]); }
__inline const CString eucjp_to_CString(const std::vector<char>& eucjp) { return CString(& eucjp_to_tcs(&eucjp[0])[0]); }



// ==========================================================================

///+++ %20 gꂽurlʏ̕ɕϊ.
const std::vector<char>		urlstr_decode(const TCHAR* url);
const CString				urlstr_decodeJpn(const TCHAR* url, int dfltCode=0);

///+++ ʏ̕ %20 gꂽurlɕϊ.
const CString				urlstr_encode(const char* str);
__inline const CString		urlstr_encode(const std::vector<char>& str) { return urlstr_encode(&str[0]); }

///+++ 񒆂ɁASJISɕϊłȂUNICODEĂꍇAŜurlstrɕϊ.
const CString 				urlstr_encodeWhenNeedUnicode(const CString& str);

///+++ 񂪔ppL݂̂ł%ĂꍇAutf8GR[ĥƂăfR[h.
const CString 				urlstr_decodeWhenASC(const CString& str);

///+++ UNICODEȂSJISɕϊł邩?
bool IsEnableUnicodeToSJIS(LPCWSTR pStr);

// ==========================================================================

//+++ t@CpXAt@C擾
const CString	GetFileBaseName(const CString& strFileName);

//+++ t@CpXAfBNg擾. Ō'\\'͊܂܂Ȃ.
const CString	GetDirName(const CString& strFileName);

///+++ t@C̊gq̎擾.  ʂ̕ɂ'.'͊܂܂Ȃ.
const CString	GetFileExt(const CString& strFileName);

///+++ tH_gq̃t@C̎擾.  ʂ̕ɂ'.'͊܂܂Ȃ.
const CString	GetFileBaseNoExt(const CString& strFileName);

///+++ gq̃t@C̎擾.  ʂ̕ɂ'.'͊܂܂Ȃ.
const CString	GetFileNameNoExt(const CString& strFileName);

//+++ ttp://h𑫂A[̋󔒂폜肷(SearchBar.h̊֐番)
void	StrToNormalUrl(CString& strUrl);



// ==========================================================================

inline bool IsExistFile(LPCTSTR fname) { return ::GetFileAttributes(fname) != 0xFFFFFFFF; }

//+++	strFile .bak t@Cɕϖ. Â .bak ΂͍폜.
void	MoveToBackupFile(const CString& strFileName);


///+++ JgfBNg̎擾.
const CString GetCurDirectory();

//+++
int SetCurDirectory(const CString& strDir);


///+++ 蔲ȃtpX. ͂̋؂'/'.
const CString MakeFullPath(const CString& strDefaultDir, const CString& strFileName);

///+++
void 	StrBkSl2Sl(CString& str);

///+++ eLXgt@C𕶎ƂĎ擾.
const CString FileLoadTextString(LPCTSTR strFile);

///+++ t@CTCYԂ.
size_t			GetFileSize(const TCHAR* fname);

///+++ t@C̃[h.
void*			FileLoad(const TCHAR* fname, void* mem, size_t size);

///+++ t@C̃[h.
template<class CHAR_VECTOR>
size_t	FileLoad(const TCHAR* fname, CHAR_VECTOR& vec) {
	enum { CHAR_SIZE = sizeof(vec[0]) };
	vec.clear();
	size_t	l = GetFileSize(fname);
	if (l > 0x1000000)		//+++ Ƃ肠AK 16MoCgőł~߂ɂƂ
		l = 0x1000000;
	size_t	n = l / CHAR_SIZE;
	if (n > 0) {
		vec.resize(n);
		FileLoad(fname, &vec[0], n * CHAR_SIZE);
	}
	return n;
}



// ==========================================================================

///+++ undonut.exẽtpXԂ.  (MtlGetModuleFileNameƈꏏ...)
const CString 	GetExeFileName();

///+++ exe(dll)̂tH_Ԃ. Ō'\\'t
const CString 	GetExeDirectory();

///+++ exe(dll)̂tH_Ԃ. Ō'\\'tȂ
const CString 	GetExeDirName();

//+++ .manifest̑݃`FbN	 CThemeDLLLoader Ɨ & ƃl[
bool  			IsExistManifestFile();

///+++ 蔲ȃtpX. fBNg̎w肪Ȃ΁AundonuttH_ƂȂ.
const CString 	GetFullPath_ForExe(const CString& strFileName);



// ==========================================================================

//+++ G[Oo.
void ErrorLogPrintf(const TCHAR* fmt, ...);


// ==========================================================================

BOOL	IsWow64(); 					//+++
unsigned getIEMejourVersion();		//+++


// ==========================================================================

#if _ATL_VER >= 0x700
typedef ATL::CRegKey  CRegKey;
#else	//+++ wtl7ȍ~ dlς悤Ȃ̂ŁAatl3̏ꍇ̓bvĎĂ.
class CRegKey : public ATL::CRegKey {
public:
	CRegKey() throw() {;}
	// CRegKey( CRegKey& key ) throw() : ATL::CRegKey(key) { ; }
	// explicit CRegKey(HKEY hKey) throw() : ATL::CRegKey(hKey) {;}

	//+++	ATL3nŃRpCł悤ɂ邽߂̃bp[֐
	HRESULT 	QueryStringValue(const TCHAR* key, TCHAR* dst, DWORD* pCount) { return this->QueryValue(dst, key, pCount); }
	HRESULT 	SetStringValue(const TCHAR* value, const TCHAR* key) { return this->SetValue(value ? value : _T(""), key); }
	HRESULT 	QueryDWORDValue(const TCHAR* key, DWORD& value) { return this->QueryValue(value, key); }
	HRESULT 	SetDWORDValue(const TCHAR* key, DWORD value) { return this->SetValue(value, key); }
};
#endif


bool setHeapAllocLowFlagmentationMode();
bool mallocHeapCompact();

}	// namespace Misc


//using namespace Misc;			//+++ 蔲
using Misc::ErrorLogPrintf;		//+++ fobOpȂły...

#endif
